unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ComCtrls,
  ExtCtrls, ValEdit, Grids, fppdfobjects, fppdfparser, DOM, XMLRead;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    ListView1: TListView;
    Memo1: TMemo;
    Memo2: TMemo;
    OpenDialog1: TOpenDialog;
    PageControl1: TPageControl;
    Splitter1: TSplitter;
    StringGrid1: TStringGrid;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    TreeView1: TTreeView;
    procedure Button1Click(Sender: TObject);
    procedure TreeView1Click(Sender: TObject);
  private
    FXMLDoc: TXMLDocument;

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  S: ansistring;
  instream: TMemoryStream;
  outstream: TStringStream;
  F : TFileStream;
  P : TPDFParser;
  Doc : TPDFDocument;
  Obj : TPDFObject;
  I : Integer;
  node, textnode: TDOMNode;

  procedure DoFill(AOwner:TTreeNode; Node:TDOMNode);
    var
      i: integer;
      AItem:TTreeNode;
    begin
      if not Assigned(Node) then exit;
      for i:=0 to Node.ChildNodes.Count - 1 do
      begin
        AItem:=TreeView1.Items.AddChild(AOwner, Node.ChildNodes[i].NodeName);
        AItem.Data:=Node.ChildNodes[i];
        if not Assigned(TreeView1.Selected) then
          TreeView1.Selected:=AItem;
        DoFill(AItem, Node.ChildNodes[i]);
      end;
    end;

begin

  //if OpenDialog1.Execute then begin
    P:=Nil;
    Doc:=Nil;
    //F:=TFileStream.Create(OpenDialog1.FileName,fmOpenRead or fmShareDenyWrite);
    F:=TFileStream.Create('/home/konrad/laz_projekte/ZUGFeRD/zugferd/DE/Beispiele/XRECHNUNG/XRECHNUNG_Einfach.pdf',fmOpenRead or fmShareDenyWrite);
    try
      Doc:=TPDFDocument.Create();
      P:=TPDFParser.Create(F);
      P.ParseDocument(Doc);
      For I := 0 to Doc.Count - 1 do
      begin
        if TPdfIndirect(Doc.Objects[I]).ElementType = peIndirectObject then begin
          Memo2.Append('Objekt ' + IntToStr(I) + ': ' + TPdfIndirect(Doc.Objects[I]).ClassName);
          Memo2.Append(TPdfIndirect(Doc.Objects[I]).GetDescription);



          if TPdfIndirect(Doc.Objects[I]).ObjectType = 'EmbeddedFile' then begin
            instream := TMemoryStream.Create;
            outstream := TStringStream.Create;
            try
              instream.WriteBuffer(TPdfIndirect(Doc.Objects[I]).Stream.Data,Length(TPdfIndirect(Doc.Objects[I]).Stream.Data));
              instream.Position := 0;
              P.Deflate(instream, outstream);
              S := outstream.DataString;
              Memo1.Text:=S;
              outstream.Position := 0;
              ReadXMLFile(FXMLDoc,outstream);
              node := FXMLDoc.DocumentElement.FindNode('rsm:ExchangedDocument');
              node := node.FindNode('ram:ID');
              textnode := node.FirstChild;
              StringGrid1.Rows[1].AddStrings(['ram:ID', 'Beleg-Nr.', textnode.TextContent]);
              node := node.ParentNode.FindNode('ram:TypeCode');
              textnode := node.FirstChild;
              StringGrid1.Rows[2].AddStrings(['ram:TypeCode', 'Funktionstyp der Rechnung',textnode.TextContent]);
              node := node.ParentNode.FindNode('ram:IssueDateTime');
              node := node.FindNode('udt:DateTimeString');
              textnode := node.FirstChild;
              StringGrid1.Rows[3].AddStrings(['ram:IssueDateTime', 'Belegdatum',textnode.TextContent]);
              node := node.ParentNode.ParentNode.FindNode('ram:IncludedNote');
              textnode := node.FirstChild;
              StringGrid1.Rows[4].AddStrings(['ram:IncludedNote', 'Betreff',textnode.TextContent]);


            finally
              instream.free;
              outstream.free;
            end;
              TreeView1.Selected:=nil;
              TreeView1.Items.BeginUpdate;
              TreeView1.Items.Clear;
              DoFill(nil, FXMLDoc);
              TreeView1.Items.EndUpdate;
              TreeView1Click(nil);
          end;
        end;
      end;
    finally
      Doc.Free;
      P.Free;
      F.Free;
    end;
  //end;
end;

procedure TForm1.TreeView1Click(Sender: TObject);
  var
    Node:TDOMNode;
    Item:TListItem;
    i:Integer;
  begin
    Edit1.Text:='';
    Edit2.Text:='';

    if not Assigned(TreeView1.Selected) then exit;
    Node:=TDOMNode(TreeView1.Selected.Data);
    if not Assigned(Node) then exit;

    Edit1.Text:=Node.NodeName;
    Edit2.Text:=Node.NodeValue;

    ListView1.BeginUpdate;
    ListView1.Items.Clear;

    if Assigned(Node.Attributes) then
      for i:=0 to Node.Attributes.Length-1 do
      begin
        Item:=ListView1.Items.Add;
        Item.Caption:=Node.Attributes[i].NodeName;
        Item.SubItems.Add(Node.Attributes[i].NodeValue);
      end;
    ListView1.EndUpdate;
end;

end.

